<?php
/**
 * @author Daniel Knudsen <d.knudsen@spawntree.de>
 * @date 12.12.23
 */


namespace App\Tests\Functional;

use App\Enum\PartnerType;
use App\Factory\CommentFactory;
use App\Factory\MediaObjectLogoFactory;
use App\Factory\MediaObjectContactFactory;
use App\Factory\MediaObjectUserFactory;
use App\Factory\PartnerFactory;
use App\Factory\PostingFactory;
use App\Factory\TaskFactory;
use App\Factory\TaskNoteFactory;
use App\Factory\UserFactory;
use Lexik\Bundle\JWTAuthenticationBundle\Services\JWTTokenManagerInterface;
use Symfony\Bundle\FrameworkBundle\Test\KernelTestCase;
use Zenstruck\Browser\Test\HasBrowser;
use Zenstruck\Foundry\Test\Factories;
use Zenstruck\Foundry\Test\ResetDatabase;

class TaskNoteResourceTest extends KernelTestCase
{
    use HasBrowser;
    use ResetDatabase;
    use Factories;

    private JWTTokenManagerInterface $JWTManager;

    protected function setUp(): void
    {
        parent::setUp();
        $this->JWTManager = self::getContainer()->get('lexik_jwt_authentication.jwt_manager');
    }

    public function testPostTaskNote(): void
    {
        $user = UserFactory::createOne(
            [
                'firstName' => 'Peter',
                'lastName' => 'Test',
                'password' => 'test',
                'email' => 'peter@test.de',
            ]
        );

        PartnerFactory::createOne();
        $task = TaskFactory::createOne();
        TaskNoteFactory::createOne();

        $token = $this->JWTManager->create($user->object());

        $this->browser()
            ->get('/api/task_notes', [
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
            ])
            ->assertSuccessful()
            ->assertJsonMatches('"hydra:totalItems"', 1)
        ;


        $this->browser()
            ->post('/api/task_notes' , [
                'json' => [
                    'message' => 'my comment',
                    'task' => '/api/tasks/' . $task->getId(),
                ],
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ]
            ])
            ->assertSuccessful()
        ;
//
//        $this->browser()
//            ->get('/api/task_notes', [
//                    'headers' => [
//                    'Authorization' => 'Bearer ' . $token,
//                ],
//            ])
//            ->assertSuccessful()
//            ->assertJsonMatches('"hydra:totalItems"', 2)
//            ->assertJsonMatches('"hydra:member"[1].message', 'my comment')
//        ;

    }
}